{% set table = "trips_by_week" -%}
CREATE TABLE IF NOT EXISTS "{{ table }}" (
    {% for name, type in db_cols.items() -%}
    "{{ name }}" {{ type }}{{ "" if loop.last else "," }}
    {% endfor -%}
);  {# SPACING CAM BE IMPROVED #}

INSERT OR REPLACE INTO "{{ table }}" BY NAME (
    SELECT
        '{{ period_to_fetch }}'::DATE AS "period",
        COUNT(*) AS "num_trips",
        SUM(total_amount) AS "total_amount",
        SUM(trip_distance) AS "trip_distance",
        SUM(passenger_count) AS "passenger_count"
    FROM
        "trips"
    WHERE
        "pickup_datetime" >= '{{ period_to_fetch }}'::DATE AND
        "pickup_datetime" < '{{ period_to_fetch }}'::DATE + INTERVAL '1 WEEK'
);

COPY (
    SELECT *
    FROM "{{ table }}"
    ORDER BY "period"
) TO '{{ path_data }}' (HEADER, DELIMITER ',');
